#ifndef __SR_ENEMY_SPRITE_H__
#define __SR_ENEMY_SPRITE_H__

#include "SRIconSprite.h"
#include "SRObjectList.h"
#include "SRObjectTypes.h"

#define     kIconOneID          0
#define     kIconTwoID          1
#define     kFireIcon           200

#define     kSwitchCountdown    5

#define     kFireProbability    0.0175
#define     kFireForce          5
#define     kFireDistance       15

#define     kScoreValue         150

class SREnemySprite : public SRIconSprite
{
public:
    SREnemySprite( int startingID, SRObject *command );
    ~SREnemySprite();
    
    virtual int Type() { return kEnemyType; }
    virtual void Think();
    virtual bool Hit( SRObject *other );
    virtual void ChildDied( SRObject *ammo );

    void AllowFiring() { fCanFire = true; }
    bool FiringAllowed() { return fCanFire; }

protected:
    CIconHandle     fIcon1;
    CIconHandle     fIcon2;
    CIconHandle     fAmmoIcon;
    
    //SRObjectList    *fAmmoList;
    
    int             fIconSwitchTimer;
    bool            fIsIconOne;
    bool            fCanFire;
};

#endif // __SR_ENEMY_SPRITE_H__