#ifndef __SR_OBJECT_H__
#define __SR_OBJECT_H__

class SRObject
{
// constructor/destructor
protected:
    SRObject();

// tick methods
public:
    virtual ~SRObject();
    virtual void Think() = 0;
    void Move();
    virtual void Draw() = 0;
    virtual bool Hit( SRObject *other ) = 0;
    virtual int Type() = 0;
    virtual void ChildDied( SRObject * ) {}
    virtual bool WantsCollisions() { return false; }
    
// accessors
public:
    // the position is the middle of the sprite
    int xPosition() { return fX; }
    int yPosition() { return fY; }
    int xVelocity() { return fVelocityX; }
    int yVelocity() { return fVelocityY; }
    int width() { return fWidth; }
    int height() { return fHeight; }

// low-level mutators
public:
    void setX( int x ) { fX = x; }
    void setY( int y ) { fY = y; }

// high-level mutators
public:
    void pushX( int force ) { fVelocityX += force; }
    void pushY( int force ) { fVelocityY += force; }
    void push( int x, int y ) { pushX(x); pushY(y); }

// Data members
protected:
    // dimensions
    int fWidth;
    int fHeight;

    //position
    int fX;
    int fY;
    
    // velocity
    int fVelocityX;
    int fVelocityY;
    
    // acceleration
    int fAccelX;
    int fAccelY;
    
    SRObject *fParent;
};

#endif //__SR_OBJECT_H__